function res = sensorConverter(str)
% Convert the data string containing temperature measurements into numeric
% format expressed in Celsius degree

% the sensor message is composed by 2 bytes, first extract those

b1 = dec2bin(hex2dec(str(1:2)));
b2 = dec2bin(hex2dec(str(3:4)));

for i=1:8
    if length(b1)<8
        b1 = ['0' b1];
    end
    if length(b2)<8
        b2 = ['0' b2];
    end
end

b = [b1 b2];

res=0;
if b(1)=='0'
    for i=1:11
        res = res + bin2dec(b(i+1)) * 2^(7-i);
    end
else
    for i = 1 : 11
        sup=dec2bin(bin2dec(b(1+i))+1);
        b(1+i) = sup(end);
    end
    sup = dec2bin(bin2dec(b(2:12)));
    sup = dec2bin(bin2dec(sup)+1);
    while(length(sup)<12)
       sup = ['0' sup];
    end 
    b(2:12) = sup(2:12);
    for i=1:11
        res = res + bin2dec(b(i+1)) * 2^(7-i);
    end

    %negative value
    res=-res;
end