function [M,m] = bigM(A,b,XX)
% Calculates the solution of following LP problem
%
% element-wise max/min A*x-b
%            x  st. x in XX
%
%
% for XX being a structure containing fields .H .K

%% recast problem in minimum

[n,m]=size(A);

x = sdpvar(m,1);

%solver setup
%sdpopt = sdpsettings('solver','cplex');

M=zeros(n,1);
m=zeros(n,1);

for i=1:n
    x=lpsol(-A(i,:),XX.H,XX.K); %F = set(XX.H*x<=XX.K);
    %F = F + set(barA*x-Ko<=eps*ones(n(1),1));
    %sol = solvesdp(F,-A(i,:)*x,sdpopt);
    M(i) = A(i,:)*x-b(i);
    if nargout>1,
        %sol = solvesdp(F,A(i,:)*x,sdpopt);
        x=lpsol(A(i,:),XX.H,XX.K);
        m(i) = A(i,:)*x-b(i);
    end
end