% Automatically creates PDF and HTML documentation for selected files. 
% It may takes several minutes !


%% === Select m-files for publication =====================================
files = { 'LSmodel' 
          'LSmodel_example'
          'WNmodel'
          'WNmodel_example'
          };
show_code_results = [ 0
                      1
                      0
                      1 
                      ];
pdf  = 0;                    
html = 1;

        
%% === Publish to LaTeX ===================================================
if pdf,
  opt.format    = 'latex';
  %opt.outputDir = 'doc\\pdf\\sources';
  opt.outputDir = 'doc/pdf/sources';
  opt.stylesheet = 'WIDElatexStyle.xsl';
  % -----------------------------------------------
  for i=1:length(files),
    opt.showCode  = (show_code_results(i)~=0);
    opt.evalCode  = (show_code_results(i)~=0);
    publish(files{i},opt);
    close all;
  end
end


%% Compile TEX files (Windows only?)
if pdf,
  cd('./doc/pdf/sources');
  for i=1:length(files),
    system(['latex ' files{i}]);
    system(['dvips ' files{i}]);
    system(['ps2pdf ' files{i} '.ps ' files{i} '.pdf']);
    system(['move ' files{i} '.pdf ../' files{i} '.pdf']);
  end
  cd('../../..');
end


%% === Publish to HTML ====================================================
if html,
  clear opt
  opt.format    = 'html';
  opt.outputDir = 'doc/html';
  %opt.stylesheet = 'WIDEhtmlStyle.xsl';
  % -----------------------------------------------
  for i=1:length(files),
    opt.showCode  = (show_code_results(i)~=0);
    opt.evalCode  = (show_code_results(i)~=0);
    publish(files{i},opt);
    close all;
  end
end



%% === View Selected Result ===============================================
if pdf,
  cd('./doc/pdf');
  open('WNmodel_example.pdf');
  cd('../..');
end

 
 