% OBJ = RLS(N_SUBS, MAX_ORDER, EXT_OUTPUTS, EXT_INPUTS) creates random
% Large Scale model with N_SUBS subsystems, EXT_OUTPUTS external outputs
% and EXT_INPUTS external inputs.

function obj = rls(n_subs, max_order, ext_outputs, ext_inputs) 
  max_outputs = 2;
  max_inputs  = 2;
  n_sums = round(n_subs/2);
    

  y_cnt = 0;
  signals = {};
  for i=1:n_subs,
    n_n   = randi(max_order);
    n_in  = randi(max_inputs);
    n_out = randi(max_outputs);
    M{i} = rss( n_n, n_out, n_in);
    M{i}.Name = [ 'subs' num2str(i) ];
    
    % ---------------------------------    
    
    sig = {};
    for j=1:n_out,
      y_cnt = y_cnt + 1;
      sig = [ sig , ['s' num2str(y_cnt)] ];
    end
    signals = [signals , sig];
    M{i}.OutputName = sig;                
  end
  
  n_subs_y = length(signals);
  input_names = strseq('s',length(signals)+1 : length(signals)+ext_inputs)';
  signals = [signals , input_names];
  y_cnt = length(signals);
      
  sum_outputs = {};
  for i=1:n_sums,
    y_cnt = y_cnt + 1;
    sum_outputs = [ sum_outputs , ['s' num2str(y_cnt)] ];       
    
    ind   = randperm( length(signals) );
    n_sig = randi([2 5]);    
    sel = signals(ind(1:n_sig));
    str=['''s' num2str(y_cnt) ''','];
    for j=1:length(sel),
      str = [str '''' sel{j} ''','];
    end
    str = str(1:end-1);    
    eval(['SUM{i}=sumblk(' str ');']);        
  end
  
  signals = [signals , sum_outputs];
  
  
  % ---------------------------------------  
  
  for i=1:n_subs,
    ind = randperm( length(signals) );
    M{i}.InputName = signals(ind( 1 : size(M{i}.B,2) ));
  end
  
  for i=1:length(input_names),
    ind = randi(length(input_names));
    M{ind}.InputName{ randi(size(M{ind}.B,2)) } = input_names{i};
  end
  
  % ---------------------------------------  
  
  ind = randperm( n_subs_y );
  output_names = signals(ind(1:ext_outputs));
  
  % ---------------------------------------    
  
  obj = LSmodel(M,SUM,input_names,output_names);
  
end