
function JJ = JordanBlocks(J)

  % Initialize output
  JJ = cell(0);

  % Check for trivial cases first
  switch size(J,1)
    case 0, JJ = {};      % Empty
    case 1, JJ = { J };  % Case 1x1
    case 2,               % Case 2x2
      if (J(1,2) ~= 0)
        JJ = {J};
      else
        JJ = {J(1,1), J(2,2)};
      end;

    otherwise             % Case >= 3x3              
      
      % Extract diagonal and superdiagonal into vector data (with padding)
      data = zeros(size(J,1),4);
      data(1:end-1,1) = diag(J,-1);
      data(1:end  ,2) = diag(J, 0);
      data(1:end-1,3) = diag(J, 1);
      data(1:end-2,4) = diag(J, 2);
      
      % ... walk over the data rows (i.e. diagonal entries)
      while size(J,1) > 0;

        % Check whether entry is complex (otherwise it is real)
        %   -- set blocksize and multiplicity diagonal
        if (data(1,1) == -data(1,3) && data(1,1) ~= 0)
          bs = 2; md = 4;
        else
          bs = 1; md = 3;
        end;
        
        % Check multiplicity
        k = bs;
        while (data(k, md) == 1)
          k = k + bs;
        end;
        JJ(length(JJ)+1) = {J(1:k,1:k)};
        
        % Remove processed part (shrink data and J matrices) of the input matrix (eat it)
        data = data(k+1:end,:);
        J = J(k+1:end,k+1:end);

      end;
  end;

% endfunction