function varargout = ncsEditor(varargin)
% ncsEditor M-file for ncsEditor.fig
%      ncsEditor, by itself, creates a new ncsEditor or raises the existing
%      singleton*.
%
%      H = ncsEditor returns the handle to a new ncsEditor or the handle to
%      the existing singleton*.
%
%      ncsEditor('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in ncsEditor.M with the given input arguments.
%
%      ncsEditor('Property','Value',...) creates a new ncsEditor or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before ncsEditor_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ncsEditor_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help ncsEditor

% Last Modified by GUIDE v2.5 14-Sep-2010 11:38:07

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ncsEditor_OpeningFcn, ...
                   'gui_OutputFcn',  @ncsEditor_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT




% --- Executes just before ncsEditor is made visible.
function ncsEditor_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ncsEditor (see VARARGIN)

% Choose default command line output for ncsEditor
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes ncsEditor wait for user response (see UIRESUME)
% uiwait(handles.ncsEditor);


% --- Outputs from this function are returned to the command line.
function varargout = ncsEditor_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --------------------------------------------------------------------
function File_Callback(hObject, eventdata, handles)
% hObject    handle to File (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Export_Callback(hObject, eventdata, handles)
% hObject    handle to Export (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

ncs = buildNcs(handles);
if isempty(ncs) == 0
    
    prompt = {'Enter NCS name:'};
    title = 'Save NCS';
    lines = 1;
    
    if strcmp(strtok(get(handles.A,'String'),'.'),get(handles.A,'String'))==0
        def = strtok(get(handles.A,'String'),'.');
    elseif strcmp(strtok(get(handles.B,'String'),'.'),get(handles.B,'String'))==0
        def = strtok(get(handles.B,'String'),'.');
    elseif strcmp(strtok(get(handles.C,'String'),'.'),get(handles.C,'String'))==0
        def = strtok(get(handles.C,'String'),'.');    
    else
        def = {'my_ncs'};
    end
    answer = inputdlg(prompt, title, lines, def);
    if isempty(answer) == 0
        assignin('base', answer{1}, ncs);
    end
else
    clear ncs
end

% --------------------------------------------------------------------
function Import_Callback(hObject, eventdata, handles)
% hObject    handle to Import (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

S= evalin('base','whos');
NcsNames = cell(0);
for ctr = 1:length(S)
    if strcmp(S(ctr).class,'ncs')
       NcsNames{ctr} = S(ctr).name;
    end
end
NcsNames(cellfun(@isempty,NcsNames)) = [];

if isempty(NcsNames) == 0
    [Selection,OK] = listdlg('ListString',NcsNames,'SelectionMode','single', ...
                     'Name','Load NCS', ...
                     'PromptString','Select NCS from Workspace:', 'ListSize', [160 100]);
    if OK == 1
        set(handles.A,'String',strcat(NcsNames(Selection),'.A'));
        set(handles.B,'String',strcat(NcsNames(Selection),'.B'));
        set(handles.C,'String',strcat(NcsNames(Selection),'.C'));
        ctrlType = evalin('base',char(strcat(NcsNames(Selection),'.ctrlType')));
        switch ctrlType
            case 'Static Feedback'
                set(handles.controllerType,'Value',1);
                controllerType_Callback(handles.controllerType,eventdata,handles);
                set(handles.Ac,'String',strcat(NcsNames(Selection),'.K'));
            case 'D-LTI Observer-Based Feedback'
                set(handles.controllerType,'Value',2);
                controllerType_Callback(handles.controllerType,eventdata,handles);
                set(handles.Ac,'String',strcat(NcsNames(Selection),'.K'));
                set(handles.Bc,'String',strcat(NcsNames(Selection),'.L'));
            case {'C-LTI Dynamic Feedback', 'D-LTI Dynamic Feedback'}
                set(handles.controllerType,'Value',3);
                controllerType_Callback(handles.controllerType,eventdata,handles);
                set(handles.Ac,'String',strcat(NcsNames(Selection),'.Ac'));
                set(handles.Bc,'String',strcat(NcsNames(Selection),'.Bc'));
                set(handles.Cc,'String',strcat(NcsNames(Selection),'.Cc'));
                set(handles.Dc,'String',strcat(NcsNames(Selection),'.Dc'));
        end
        
        hmin = evalin('base',char(strcat(NcsNames(Selection),'.h(1)')));
        set(handles.hmin,'String',num2str(hmin));
        set(handles.hmin,'ForegroundColor','black')
        hmax = evalin('base',char(strcat(NcsNames(Selection),'.h(2)')));
        set(handles.hmax,'String',num2str(hmax));
        set(handles.hmax,'ForegroundColor','black')
        taumin = evalin('base',char(strcat(NcsNames(Selection),'.tau(1)')));
        set(handles.taumin,'String',num2str(taumin));
        set(handles.taumin,'ForegroundColor','black')
        taumax = evalin('base',char(strcat(NcsNames(Selection),'.tau(2)')));
        set(handles.taumax,'String',num2str(taumax));
        set(handles.taumax,'ForegroundColor','black')
        delta = evalin('base',char(strcat(NcsNames(Selection),'.delta')));
        set(handles.delta,'String',num2str(delta));
        set(handles.delta,'ForegroundColor','black')
        gammaU = evalin('base',char(strcat(NcsNames(Selection),'.gammaU')));
        gammaY = evalin('base',char(strcat(NcsNames(Selection),'.gammaY')));
        B = evalin('base',char(strcat(NcsNames(Selection),'.B')));
        C = evalin('base',char(strcat(NcsNames(Selection),'.C')));
        
        if length(gammaU) == 1 && length(gammaY) == 1 && sum(sum(gammaU{1})) + sum(sum(gammaY{1})) == size(B,2)+size(C,2)
            set(handles.checkbox1,'Value',0);
            checkbox1_Callback(handles.checkbox1, eventdata, handles)
        else

            nodeList = cell(0);
            for ctr = 1:length(gammaU)
                if ctr <= 9
                    nodeList{ctr} = ['node' num2str(ctr) '     '];
                else
                    nodeList{ctr} = ['node' num2str(ctr) '    '];
                end

                for ctr2=1:size(gammaU{ctr},1)
                    if gammaU{ctr}(ctr2,ctr2) == 1
                        if ctr2 <= 9
                            nodeList{ctr} = [nodeList{ctr} 'u0' num2str(ctr2) ','];
                        else
                            nodeList{ctr} = [nodeList{ctr} 'u' num2str(ctr2) ','];
                        end
                    end
                end

                for ctr2=1:size(gammaY{ctr},1)
                    if gammaY{ctr}(ctr2,ctr2) == 1
                        if ctr2 <= 9
                            nodeList{ctr} = [nodeList{ctr} 'y0' num2str(ctr2) ',']; 
                        else
                            nodeList{ctr} = [nodeList{ctr} 'y' num2str(ctr2) ',']; 
                        end
                    end
                end
                if nodeList{ctr}(end) == ',' 
                    nodeList{ctr} = nodeList{ctr}(1:end-1);   %remove last comma
                end
            end
            set(handles.nodeList,'String',nodeList);
            set(handles.checkbox1,'Value',1);
            set(handles.nodeList,'Value',1);
            set(handles.pushbutton4,'Enable','on');
            set(handles.nodeList,'Enable','on');
            set(handles.protocolChoice,'Enable','on');
        end
        
        protocol = evalin('base',char(strcat(NcsNames(Selection),'.protocol')));
        
        if strcmp(protocol,'RR')
            set(handles.protocolChoice,'Value',1); 
        elseif strcmp(protocol,'TOD')
            set(handles.protocolChoice,'Value',2); 
        end
        
    end
else
    msgbox('No NCS variables in workspace')
end


% --------------------------------------------------------------------
function Close_Callback(hObject, eventdata, handles)
% hObject    handle to Close (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
button = questdlg('Are you sure you want to quit?  All un-exported data will be lost.','NCS Editor','Ok','Cancel','Cancel'); 
if strcmp(button,'Ok')
    delete(handles.ncsGui);
end

% --- Executes during object creation, after setting all properties.
function delta_CreateFcn(hObject, eventdata, handles)
% hObject    handle to delta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function ncs1 = buildNcs(handles)
    %-------------------------------------------------------------------    
    %check A,B,C conditions
    try
        A = evalin('base',char(get(handles.A,'String')));
    catch
        msgbox('Invalid value for input field A entered','NCS Toolbox Error','error')
        ncs1 =[];
        return
    end

     if isnumeric(A) == 0
         msgbox('Input field A must be a matrix of type double','NCS Toolbox Error','error')
         ncs1 =[];
        return
     elseif size(A,1) ~= size(A,2)
        msgbox('Input field A must be a square matrix','NCS Toolbox Error','error')
        ncs1 =[];
        return
     end
    
    
    try
        B = evalin('base',char(get(handles.B,'String')));
    catch
        msgbox('Invalid value for input field B entered','NCS Toolbox Error','error')
        ncs1 =[];
        return
    end
    
     if isnumeric(B) == 0
         msgbox('Input field B must be a matrix of type double','NCS Toolbox Error','error')
         ncs1 =[];
        return
     elseif size(A,2) ~= size(B,1)
        msgbox('Number of rows of A must match number of rows of B','NCS Toolbox Error','error')
        ncs1 =[];
        return
     end
     
    try
        C = evalin('base',char(get(handles.C,'String')));
    catch
        msgbox('Invalid value for input field C entered','NCS Toolbox Error','error')
        ncs1 =[];
        return
    end
    
     if isnumeric(C) == 0
         msgbox('Input field C must be a matrix of type double','NCS Toolbox Error','error')
         ncs1 =[];
        return
     elseif size(A,2) ~= size(C,2)
        msgbox('Number of columns of A must match number of columns of C','NCS Toolbox Error','error')
        ncs1 =[];
        return
     end 
    %------------------------------------------------------------------- 
    %-------------------------------------------------------------------    
    %check Controller conditions    
    
    contents = get(handles.controllerType,'String');
    controllerType = contents{get(handles.controllerType,'Value')};
    
    switch controllerType
        %-------------------------------------------------------------------    
        %Static Feedback checks
        case 'Static Feedback'
            if isempty(get(handles.Ac,'String')) == 0
                try
                    temp = evalin('base',char(get(handles.Ac,'String')));
                catch
                    msgbox('Invalid value for input field K entered','NCS Toolbox Error','error')
                    ncs1 =[];
                    return
                end   
            else
                temp=[];
            end
            
            if isnumeric(temp)
                K{1} = temp;
            else
                K = temp;
            end
            
            if length(K) ~= 1 && length(K) ~= length(get(handles.nodeList,'String'))
                    msgbox('K must be a single matrix or a cell whose length is equal to the number of nodes','NCS Toolbox Error','error')
                    ncs1 =[];
                    return
            end 
            
            for ctr = 1:length(K)
                if isnumeric(K{ctr}) == 0
                     msgbox('Input field K must either a matrix of type double or a cell of matrices type double','NCS Toolbox Error','error')
                     ncs1 =[];
                    return
                elseif isempty(K{ctr}) == 0 && size(B,2) ~= size(K{ctr},1)
                    msgbox('Number of columns of B must match number of rows of K','NCS Toolbox Error','error')
                    ncs1 =[];
                    return
                elseif isempty(K{ctr}) == 0 && size(A,1) ~= size(K{ctr},2)
                    msgbox('Number of columns of K must match number of rows of A','NCS Toolbox Error','error')
                    ncs1 =[];
                    return
                end
            end
        %-------------------------------------------------------------------    
        %Obsver-based Feedback checks
        case 'D-LTI  Observer-Based Feedback'
            
            if isempty(get(handles.Ac,'String')) == 0
                try
                    temp = evalin('base',char(get(handles.Ac,'String')));
                catch
                    msgbox('Invalid value for input field K entered','NCS Toolbox Error','error')
                    ncs1 =[];
                    return
                end   
            else
                temp=[];
            end

            if isnumeric(temp)
                K{1} = temp;
            else
                K = temp;
            end
            
            if isempty(get(handles.Bc,'String')) == 0
                try
                    temp = evalin('base',char(get(handles.Bc,'String')));
                catch
                    msgbox('Invalid value for input field K entered','NCS Toolbox Error','error')
                    ncs1 =[];
                    return
                end   
            else
                L{1}=[];
            end
            
            if isnumeric(temp)
                L{1} = temp;
            else
                L = temp;
            end
            
            if length(K) ~= length(L)
                    msgbox('Number of K matrices does not equal number of L matrices','NCS Toolbox Error','error')
                    ncs1 =[];
                    return
            end
            
            if length(K) ~= 1 && length(K) ~= length(get(handles.nodeList,'String'))
                msgbox('K and L must be single matrices or cells whose length is equal to the number of nodes','NCS Toolbox Error','error')
                ncs1 =[];
                return
            end 
            
            
            for ctr = 1:length(K)
                if isnumeric(K{ctr}) == 0
                     msgbox('Input field K must either a matrix of type double or a cell of matrices type double','NCS Toolbox Error','error')
                     ncs1 =[];
                    return
                elseif isempty(K{ctr}) == 0 && size(B,2) ~= size(K{ctr},1)
                    msgbox('Number of columns of B must match number of rows of K','NCS Toolbox Error','error')
                    ncs1 =[];
                    return
                elseif isempty(K{ctr}) == 0 && size(A,1) ~= size(K{ctr},2)
                    msgbox('Number of columns of K must match number of rows of A','NCS Toolbox Error','error')
                    ncs1 =[];
                    return
                end

                if isnumeric(L{ctr}) == 0
                     msgbox('Input field L must either a matrix of type double or a cell of matrices type double','NCS Toolbox Error','error')
                     ncs1 =[];
                    return
                elseif isempty(L{ctr}) == 0 && size(C,2) ~= size(L{ctr},1)
                    msgbox('Number of columns of C must match number of rows of L','NCS Toolbox Error','error')
                    ncs1 =[];
                    return
                elseif isempty(L{ctr}) == 0 && size(A,1) ~= size(L{ctr},1)
                    msgbox('Number of columns of L must match number of rows of C','NCS Toolbox Error','error')
                    ncs1 =[];
                    return
                end
            end
        %-------------------------------------------------------------------    
        %Dynamic Feedback checks    
        case {'C-LTI  Dynamic Feedback', 'D-LTI  Dynamic Feedback'}
            try
               temp = evalin('base',char(get(handles.Ac,'String')));
            catch
                msgbox('Invalid value for input field Ac entered','NCS Toolbox Error','error')
                ncs1 =[];
                return
            end

            if isnumeric(temp)
                Ac{1} = temp;
            else
                Ac = temp;
            end
            
            try
                temp = evalin('base',char(get(handles.Bc,'String')));
            catch
                msgbox('Invalid value for input field Bc entered','NCS Toolbox Error','error')
                ncs1 =[];
                return
            end
            
            if isnumeric(temp)
                Bc{1} = temp;
            else
                Bc = temp;
            end
            
            try
                temp = evalin('base',char(get(handles.Cc,'String')));
            catch
                msgbox('Invalid value for input field Cc entered','NCS Toolbox Error','error')
                ncs1 =[];
                return
            end
            
            if isnumeric(temp)
                Cc{1} = temp;
            else
                Cc = temp;
            end  
            
            try
                temp = evalin('base',char(get(handles.Dc,'String')));
            catch
                msgbox('Invalid value for input field Dc entered','NCS Toolbox Error','error')
                ncs1 =[];
                return
            end

            if isnumeric(temp)
                Dc{1} = temp;
            else
                Dc = temp;
            end
            
           if length(Ac) ~= length(Bc) || length(Ac) ~= length(Cc) || length(Ac) ~= length(Dc)
                msgbox('Number of controller matrices does are equal number for each cell','NCS Toolbox Error','error')
                ncs1 =[];
                return
           end
           
           if length(Ac) ~= 1 && length(Ac) ~= length(get(handles.nodeList,'String'))
                msgbox('Ac,Bc,Cc,Dc must be a set of single matrices or a set of cells whose length is equal to the number of nodes','NCS Toolbox Error','error')
                ncs1 =[];
                return
           end  
           
           
           for ctr = 1:length(Ac)
                
                 if isnumeric(Ac{ctr}) == 0
                     msgbox('Input field Ac must be a matrix of type double','NCS Toolbox Error','error')
                     ncs1 =[];
                    return
                 elseif size(Ac{ctr},1) ~= size(Ac{ctr},2)
                    msgbox('Input field Ac must be a square matrix','NCS Toolbox Error','error')
                    ncs1 =[];
                    return
                 end

                 if isnumeric(Bc{ctr}) == 0
                     msgbox('Input field Bc must be a matrix of type double','NCS Toolbox Error','error')
                     ncs1 =[];
                    return
                 elseif size(Ac{ctr},2) ~= size(Bc{ctr},1)
                    msgbox('Number of columns of Ac must match number of rows of Bc','NCS Toolbox Error','error')
                    ncs1 =[];
                    return
                 end



                 if isnumeric(Cc{ctr}) == 0
                     msgbox('Input field Cc must be a matrix of type double','NCS Toolbox Error','error')
                     ncs1 =[];
                    return
                 elseif size(Ac{ctr},2) ~= size(Cc{ctr},2)
                    msgbox('Number of columns of Ac must match number of columns of Cc','NCS Toolbox Error','error')
                    ncs1 =[];
                    return
                 end

                 if isnumeric(Dc{ctr}) == 0
                     msgbox('Input field Dc must be a matrix of type double','NCS Toolbox Error','error')
                     ncs1 =[];
                    return
                 elseif size(Bc{ctr},2) ~= size(Dc{ctr},2)
                    msgbox('Number of columns of Bc must match number of columns of Dc','NCS Toolbox Error','error')
                    ncs1 =[];
                    return
                elseif size(Cc{ctr},1) ~= size(Dc{ctr},1)
                    msgbox('Number of rows of Cc must match number of rows of Dc','NCS Toolbox Error','error')
                    ncs1 =[];
                    return
                 end
            end
    end
    %-------------------------------------------------------------------    
    %check transmission interval conditions
    try
        hmin = evalin('base',char(get(handles.hmin,'String')));
    catch
        msgbox('Invalid value for minimum transmission interval entered','NCS Toolbox Error','error')
        ncs1 =[];
        return
    end
    
    if isnumeric(hmin) == 0 || numel(hmin)~=1 || hmin < 0
         msgbox('The minimum transmission interval must be a positive scalar of type double','NCS Toolbox Error','error')
         ncs1 =[];
         return
    end
    
    try
        hmax = evalin('base',char(get(handles.hmax,'String')));
    catch
        msgbox('Invalid value for maximum transmission interval entered','NCS Toolbox Error','error')
        ncs1 =[];
        return
    end   
    
    if isnumeric(hmax) == 0 || numel(hmax)~=1 || hmax < 0
        msgbox('The maximum transmission interval must be a positive scalar of type double','NCS Toolbox Error','error')
        ncs1 =[];
        return
    end
   
    if hmin > hmax
       msgbox('The minimum transmission interval must be greater than or equal to the maximum transmission interval','NCS Toolbox Error','error')
       ncs1 =[];
       return
    end
    
    %-------------------------------------------------------------------    
    %check delay interval conditions
    
    try
        taumin = evalin('base',char(get(handles.taumin,'String')));
    catch
        msgbox('Invalid value for minimum delay entered','NCS Toolbox Error','error')
        ncs1 =[];
        return
    end   

    if isnumeric(taumin) == 0 || numel(taumin)~=1 || taumin < 0
         msgbox('The minimum delay must be a positive scalar of type double','NCS Toolbox Error','error')
         ncs1 =[];
         return
    end
    
    try
        taumax = evalin('base',char(get(handles.taumax,'String')));
    catch
        msgbox('Invalid value for maximum delay entered','NCS Toolbox Error','error')
        ncs1 =[];
        return
    end   
    
    if isnumeric(taumax) == 0 || numel(taumax)~=1 || taumax < 0
        msgbox('The maximum delay must be a positive scalar of type double','NCS Toolbox Error','error')
        ncs1 =[];
        return
    end    
    
   
    if taumin > taumax
       msgbox('The minimum delay must be greater than or equal to the maximum delay','NCS Toolbox Error','error')
       ncs1 =[];
       return
    end    
     
    
    %-------------------------------------------------------------------    
    %check dropout conditions
            
    try
        delta = evalin('base',char(get(handles.delta,'String')));
    catch
        msgbox('Invalid value for max dropouts entered','NCS Toolbox Error','error')
        ncs1 =[];
        return
    end   
    
    if isnumeric(delta) == 0 || delta - round(delta) ~= 0 || delta < 0
        msgbox('Invalid delta parameter, must be a positive integer','NCS Toolbox Error','error')
        ncs1 =[];
        return
    end
    
    %-------------------------------------------------------------------    
    %Create Gamma matrics
    
    contents = get(handles.nodeList,'String');
    
    if isempty(contents) == 0 
    
        GammaU = cell(1,length(contents));
        GammaY = cell(1,length(contents));
        for ctr = 1:length(contents)
           GammaU{ctr} = zeros(size(B,2));
           GammaY{ctr} = zeros(size(C,1));

           if isempty(contents{ctr}(11:end))==0
                data=textscan(contents{ctr}(11:end),'%s','delimiter',',');

                for ctr2 =1:length(data{1})
                    spot = str2double(data{1}{ctr2}(2:end));
                    if strcmp(data{1}{ctr2}(1),'u')
                        GammaU{ctr}(spot,spot) = 1;
                    elseif strcmp(data{1}{ctr2}(1),'y')
                        GammaY{ctr}(spot,spot) = 1;
                    end
                end
           end

       end
   else
        GammaU{1} = eye(size(B,2));
        GammaY{1} = eye(size(C,1));
   end
   contents = get(handles.protocolChoice,'String');
   protocol = contents{get(handles.protocolChoice,'Value')};
   switch controllerType
        case 'Static Feedback'
            ncs1 = ncs(A,B,C,K,[hmin hmax],[taumin taumax],delta,GammaU,GammaY,protocol);
        case 'D-LTI  Observer-Based Feedback'
            ncs1 =ncs(A,B,C,K,L,[hmin hmax],[taumin taumax],delta,GammaU,GammaY,protocol);
        case 'C-LTI  Dynamic Feedback'
            ncs1 = ncs(A,B,C,'C-LTI',Ac,Bc,Cc,Dc,[hmin hmax],[taumin taumax],delta,GammaU,GammaY,protocol);
        case 'D-LTI  Dynamic Feedback'
            ncs1 = ncs(A,B,C,'D-LTI',Ac,Bc,Cc,Dc,[hmin hmax],[taumin taumax],delta,GammaU,GammaY,protocol);
   end

   
% --- Executes during object creation, after setting all properties.
function hmin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to hmin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function taumax_CreateFcn(hObject, eventdata, handles)
% hObject    handle to taumax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function taumin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to taumin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function hmax_CreateFcn(hObject, eventdata, handles)
% hObject    handle to hmax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function edit6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --------------------------------------------------------------------
function New_Callback(hObject, eventdata, handles)
% hObject    handle to New (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Help_Callback(hObject, eventdata, handles)
% hObject    handle to Help (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function About_Callback(hObject, eventdata, handles)
% hObject    handle to About (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

msgbox({'ncsToolbox was developed by:'  ...
        ' '...
        'Hybrid and Networked Systems Group' ...
        'University of Technology Eindhoven' ...
        ' ' ...
        'Questions or Comments can be sent to n.w.bauer@tue.nl'})

% --- Executes during object creation, after setting all properties.
function A_CreateFcn(hObject, eventdata, handles)
% hObject    handle to A (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function B_CreateFcn(hObject, eventdata, handles)
% hObject    handle to B (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function Ac_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Ac (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function controllerType_CreateFcn(hObject, eventdata, handles)
% hObject    handle to controllerType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function axes3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axes3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axes3
axes(hObject)
Generate_NCS_Blockdiagram(hObject)


% --- Executes during object creation, after setting all properties.
function edit10_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function edit11_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function protocolChoice_CreateFcn(hObject, eventdata, handles)
% hObject    handle to protocolChoice (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function edit12_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function edit13_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function edit14_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function edit15_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function edit16_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit16 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function popupmenu6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function ncsGui_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ncsEditor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called



function A_Callback(hObject, eventdata, handles)
% hObject    handle to A (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of A as text
%        str2double(get(hObject,'String')) returns contents of A as a double


% --- Executes during object creation, after setting all properties.
function edit17_CreateFcn(hObject, eventdata, handles)
% hObject    handle to A (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function B_Callback(hObject, eventdata, handles)
% hObject    handle to B (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of B as text
%        str2double(get(hObject,'String')) returns contents of B as a double


% --- Executes during object creation, after setting all properties.
function edit18_CreateFcn(hObject, eventdata, handles)
% hObject    handle to B (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function C_Callback(hObject, eventdata, handles)
% hObject    handle to C (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of C as text
%        str2double(get(hObject,'String')) returns contents of C as a double


% --- Executes during object creation, after setting all properties.
function C_CreateFcn(hObject, eventdata, handles)
% hObject    handle to C (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Bc_Callback(hObject, eventdata, handles)
% hObject    handle to Bc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Bc as text
%        str2double(get(hObject,'String')) returns contents of Bc as a double


% --- Executes during object creation, after setting all properties.
function Bc_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Bc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Cc_Callback(hObject, eventdata, handles)
% hObject    handle to Cc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Cc as text
%        str2double(get(hObject,'String')) returns contents of Cc as a double


% --- Executes during object creation, after setting all properties.
function Cc_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Cc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Dc_Callback(hObject, eventdata, handles)
% hObject    handle to Dc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Dc as text
%        str2double(get(hObject,'String')) returns contents of Dc as a double


% --- Executes during object creation, after setting all properties.
function Dc_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Dc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in controllerType.
function controllerType_Callback(hObject, eventdata, handles)
% hObject    handle to controllerType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns controllerType contents as cell array
%        contents{get(hObject,'Value')} returns selected item from controllerType


contents = cellstr(get(hObject,'String'));
selection = contents{get(hObject,'Value')};

set(handles.AcText,'Visible','off')
set(handles.BcText,'Visible','off')
set(handles.CcText,'Visible','off')
set(handles.DcText,'Visible','off')

set(handles.Ac,'Visible','off')
set(handles.Bc,'Visible','off')
set(handles.Cc,'Visible','off')
set(handles.Dc,'Visible','off')


switch selection
    case 'Static Feedback'
        set(handles.AcText,'String','K:')
        set(handles.AcText,'Visible','on')
        set(handles.Ac,'Visible','on')
        
    case 'D-LTI  Observer-Based Feedback'
        set(handles.AcText,'String','K:')
        set(handles.BcText,'String','L:')
        
        set(handles.AcText,'Visible','on')
        set(handles.BcText,'Visible','on')
        
        set(handles.Ac,'Visible','on')
        set(handles.Bc,'Visible','on')
    case {'C-LTI  Dynamic Feedback', 'D-LTI  Dynamic Feedback'}
        set(handles.AcText,'String','Ac:')
        set(handles.BcText,'String','Bc:')
        set(handles.CcText,'String','Cc:')
        set(handles.DcText,'String','Dc:')
        
        set(handles.AcText,'Visible','on')
        set(handles.BcText,'Visible','on')
        set(handles.CcText,'Visible','on')
        set(handles.DcText,'Visible','on')
        
        set(handles.Ac,'Visible','on')
        set(handles.Bc,'Visible','on')
        set(handles.Cc,'Visible','on')
        set(handles.Dc,'Visible','on')
end
        
% --- Executes during object creation, after setting all properties.
function controlMode_CreateFcn(hObject, eventdata, handles)
% hObject    handle to controlMode (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object deletion, before destroying properties.
function uipanel3_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to uipanel3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function uipanel1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function uipanel2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function uipanel3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function uipanel4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object deletion, before destroying properties.
function ncsGui_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to ncsEditor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes when user attempts to close ncsEditor.
function ncsGui_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to ncsEditor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
button = questdlg('Are you sure you want to quit?  All un-exported data will be lost.','NCS Editor','Ok','Cancel','Cancel'); 
if strcmp(button,'Ok')
    delete(hObject);
end

% --- Executes during object deletion, before destroying properties.
function uipanel1_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to uipanel1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object deletion, before destroying properties.
function uipanel2_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to uipanel2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object deletion, before destroying properties.
function uipanel4_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to uipanel4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object deletion, before destroying properties.
function axes3_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to axes3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on selection change in ovraprx.
function ovraprx_Callback(hObject, eventdata, handles)
% hObject    handle to ovraprx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns ovraprx contents as cell array
%        contents{get(hObject,'Value')} returns selected item from ovraprx


% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    try
        B = evalin('base',char(get(handles.B,'String')));
    catch
        msgbox('Must first enter a valid value for input field B','NCS Toolbox Error','error')
        ncs =[];
        return
    end
    if isnumeric(B) == 0
        msgbox('Input field B must be a matrix of type double','NCS Toolbox Error','error')
        ncs =[];
       return
    end
    
    try
        C = evalin('base',char(get(handles.C,'String')));
    catch
        msgbox('Must first enter a valid value for input field C','NCS Toolbox Error','error')
        ncs =[];
        return
    end
    if isnumeric(C) == 0
        msgbox('Input field C must be a matrix of type double','NCS Toolbox Error','error')
        ncs =[];
       return
    end 
    
eval('ncsGui_handles = handles;');
savePath = what('ncsEditor');
save([savePath.path '\temp'],'ncsGui_handles');

uiwait(nodes);

load([savePath.path '\temp']);
delete([savePath.path '\temp.mat'])
if isempty(newNodeList) == 0
    set(handles.nodeList,'String',newNodeList);
end

%load('nodeGui_handles','nodeGui_handles');


% --- Executes on selection change in nodeList.
function nodeList_Callback(hObject, eventdata, handles)
% hObject    handle to nodeList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns nodeList contents as cell array
%        contents{get(hObject,'Value')} returns selected item from nodeList


% --- Executes during object creation, after setting all properties.
function nodeList_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nodeList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
set(hObject,'FontName','FixedWidth');


% --- Executes on selection change in protocolChoice.
function protocolChoice_Callback(hObject, eventdata, handles)
% hObject    handle to protocolChoice (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns protocolChoice contents as cell array
%        contents{get(hObject,'Value')} returns selected item from protocolChoice


% --- Executes on button press in checkbox1.
function checkbox1_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox1

if get(hObject,'Value') == 0
    set(handles.nodeList,'Enable','off');
    set(handles.nodeList,'String','');
    set(handles.pushbutton4,'Enable','off');
    set(handles.protocolChoice,'Enable','off');
else
    set(handles.nodeList,'Enable','on');
    set(handles.nodeList,'String',{'node1     '});
    set(handles.nodeList,'Value',1);
    set(handles.pushbutton4,'Enable','on');
    set(handles.protocolChoice,'Enable','on');   
end



function Ac_Callback(hObject, eventdata, handles)
% hObject    handle to Ac (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Ac as text
%        str2double(get(hObject,'String')) returns contents of Ac as a double


% --- Executes on key press with focus on hmax and none of its controls.
function hmax_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to hmax (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
set(hObject,'ForegroundColor','black')

% --- Executes on key press with focus on taumin and none of its controls.
function taumin_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to taumin (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
set(hObject,'ForegroundColor','black')


% --- Executes on key press with focus on hmin and none of its controls.
function hmin_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to hmin (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
set(hObject,'ForegroundColor','black')


% --- Executes on key press with focus on taumax and none of its controls.
function taumax_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to taumax (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
set(hObject,'ForegroundColor','black')


% --- Executes on key press with focus on delta and none of its controls.
function delta_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to delta (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
set(hObject,'ForegroundColor','black')



function hmin_Callback(hObject, eventdata, handles)
% hObject    handle to hmin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of hmin as text
%        str2double(get(hObject,'String')) returns contents of hmin as a double



function hmax_Callback(hObject, eventdata, handles)
% hObject    handle to hmax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of hmax as text
%        str2double(get(hObject,'String')) returns contents of hmax as a double



function taumin_Callback(hObject, eventdata, handles)
% hObject    handle to taumin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of taumin as text
%        str2double(get(hObject,'String')) returns contents of taumin as a double



function taumax_Callback(hObject, eventdata, handles)
% hObject    handle to taumax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of taumax as text
%        str2double(get(hObject,'String')) returns contents of taumax as a double


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over taumax.
function taumax_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to taumax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function delta_Callback(hObject, eventdata, handles)
% hObject    handle to delta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of delta as text
%        str2double(get(hObject,'String')) returns contents of delta as a double
