function varargout = nodes(varargin)
% NODES M-file for nodes.fig
%      NODES, by itself, creates a new NODES or raises the existing
%      singleton*.
%
%      H = NODES returns the handle to a new NODES or the handle to
%      the existing singleton*.
%
%      NODES('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in NODES.M with the given input arguments.
%
%      NODES('Property','Value',...) creates a new NODES or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before nodes_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to nodes_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help nodes

% Last Modified by GUIDE v2.5 14-Sep-2010 11:01:00

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @nodes_OpeningFcn, ...
                   'gui_OutputFcn',  @nodes_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before nodes is made visible.
function nodes_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to nodes (see VARARGIN)

% Choose default command line output for nodes
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes nodes wait for user response (see UIRESUME)
% uiwait(handles.nodeGui);


% --- Outputs from this function are returned to the command line.
function varargout = nodes_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in inputOutputList.
function inputOutputList_Callback(hObject, eventdata, handles)
% hObject    handle to inputOutputList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns inputOutputList contents as cell array
%        contents{get(hObject,'Value')} returns selected item from inputOutputList


% --- Executes during object creation, after setting all properties.
function inputOutputList_CreateFcn(hObject, eventdata, handles)
% hObject    handle to inputOutputList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

savePath = what('ncsEditor');
load([savePath.path '\temp'])

numInputs = size(evalin('base',char(get(ncsGui_handles.B,'String'))),2);
numOutputs = size(evalin('base',char(get(ncsGui_handles.C,'String'))),1);

list = cell(1,numInputs+numOutputs);

for ctr = 1:numInputs
    if ctr <= 9
        list{ctr} = strcat('u0',num2str(ctr));
    else
        list{ctr} = strcat('u',num2str(ctr));
    end
end

for ctr = 1:numOutputs
    if ctr <= 9
        list{numInputs+ctr} = strcat('y0',num2str(ctr));
    else
        list{numInputs+ctr} = strcat('y',num2str(ctr));
    end
end

set(hObject,'String',list);

% --- Executes on selection change in nodeList.
function nodeList_Callback(hObject, eventdata, handles)
% hObject    handle to nodeList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns nodeList contents as cell array
%        contents{get(hObject,'Value')} returns selected item from nodeList


% --- Executes during object creation, after setting all properties.
function nodeList_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nodeList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

savePath = what('ncsEditor');
load([savePath.path '\temp'])

nodeList = get(ncsGui_handles.nodeList,'String');

if isempty(nodeList{1}(11:end)) == 0
    data=textscan(nodeList{1}(11:end),'%s','delimiter',',');
else
    data{1} = '';
end
set(hObject,'String',data{1});

% --- Executes on button press in AddInOut.
function AddInOut_Callback(hObject, eventdata, handles)
% hObject    handle to AddInOut (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

inOutList = get(handles.inputOutputList,'String'); 
numSelected = get(handles.inputOutputList,'Value');

allNodesList = get(handles.allNodesList,'String'); 
nodeSelected = get(handles.allNodesList,'Value');


inOutNode = get(handles.nodeList,'String'); 

if isempty(inOutNode)
    inOutNode{1} = inOutList{numSelected}; 
    set(handles.nodeList,'String',inOutNode);
    set(handles.nodeList,'Value',1)
    allNodesList{nodeSelected} = [allNodesList{nodeSelected}(1:10) inOutNode{1}];
    set(handles.allNodesList,'String',allNodesList);
    return
end

%check if there is a copy already on list
okToAdd = 1;
for ctr = 1:length(inOutNode)
   if strcmp(inOutList{numSelected},inOutNode{ctr});
      okToAdd = 0; 
   end
end

if okToAdd == 1
    inOutNode{end+1} = inOutList{numSelected};
   
    inOutNode = sort(inOutNode);
    set(handles.nodeList,'String',inOutNode);
    finalStr='';
    for ctr =1:length(inOutNode)-1
        finalStr = [finalStr inOutNode{ctr} ','];
    end
    finalStr = [finalStr inOutNode{ctr+1}];
    
    allNodesList{nodeSelected} = [allNodesList{nodeSelected}(1:10) finalStr];
    set(handles.allNodesList,'String',allNodesList);
end

if numSelected ~= length(inOutList)
    set(handles.inputOutputList,'Value',numSelected+1);
end

% --- Executes on button press in RemoveInOut.
function RemoveInOut_Callback(hObject, eventdata, handles)
% hObject    handle to RemoveInOut (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

contents = get(handles.nodeList,'String'); 
 
 if length(contents) == 1
     msgbox('Must be one input or output in a node','NCS Toolbox Error')
 elseif length(contents) > 1
    allNodesList = get(handles.allNodesList,'String'); 
    nodeSelected = get(handles.allNodesList,'Value');
     
    numSelected = get(handles.nodeList,'Value');
    contents{numSelected}= '';
    contents(cellfun(@isempty,contents)) = '';
    set(handles.nodeList,'String',contents);
    set(handles.nodeList,'Value',length(contents))
    finalStr='';
    
    if length(contents) > 1
        for ctr =1:length(contents)-1
            finalStr = [finalStr contents{ctr} ','];
        end
        finalStr = [finalStr contents{ctr+1}];
    else
        finalStr = contents{1};
    end
    
    
    allNodesList{nodeSelected} = [allNodesList{nodeSelected}(1:10) finalStr];
    set(handles.allNodesList,'String',allNodesList);
 end


% --- Executes on button press in OkButton.
function OkButton_Callback(hObject, eventdata, handles)
% hObject    handle to OkButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

eval('newNodeList = get(handles.allNodesList,''String'');');
savePath = what('ncsEditor');
save([savePath.path '\temp'],'newNodeList');
delete(handles.nodeGui);

% --- Executes during object creation, after setting all properties.
function nodeGui_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nodeGui (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on selection change in allNodesList.
function allNodesList_Callback(hObject, eventdata, handles)
% hObject    handle to allNodesList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns allNodesList contents as cell array
%        contents{get(hObject,'Value')} returns selected item from allNodesList

nodeList = get(hObject,'String');
numSelected = get(hObject,'Value');

if isempty(nodeList{numSelected}(11:end)) == 0
    data=textscan(nodeList{numSelected}(11:end),'%s','delimiter',',');
else
    data{1} = '';
end
set(handles.nodeList,'String',data{1});
set(handles.nodeText,'String',['Node: ' nodeList{numSelected}(5:6)])

% --- Executes during object creation, after setting all properties.
function allNodesList_CreateFcn(hObject, eventdata, handles)
% hObject    handle to allNodesList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

savePath = what('ncsEditor');
load([savePath.path '\temp'])

set(hObject,'String',get(ncsGui_handles.nodeList,'String'))
set(hObject,'FontName','FixedWidth');


% --- Executes on button press in AddButton.
function AddButton_Callback(hObject, eventdata, handles)
% hObject    handle to AddButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
contents = get(handles.allNodesList,'String');
if length(contents) <= 8
    contents{end+1} = ['node' num2str(length(contents)+1) '     '];
else
    contents{end+1} = ['node' num2str(length(contents)+1) '    '];
end

set(handles.allNodesList,'String',contents);
set(handles.allNodesList,'Value',length(contents));
set(handles.nodeList,'String','');

% --- Executes on button press in DeleteButton.
function DeleteButton_Callback(hObject, eventdata, handles)
% hObject    handle to DeleteButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

contents = get(handles.allNodesList,'String');

if length(contents) == 1
    msgbox('Cannot delete, must have one node defined','NCS Toolbox Error')
    return
end
   
numSelected = get(handles.allNodesList,'Value');

contents{numSelected}= '';
contents(cellfun(@isempty,contents)) = '';

for ctr = numSelected:length(contents)
    contents{ctr} = ['node' num2str(ctr) contents{ctr}(6:end)];
end
if numSelected > length(contents)
    set(handles.allNodesList,'Value',length(contents))
end
set(handles.allNodesList,'String',contents);

% --- Executes on button press in moveUpButton.
function moveUpButton_Callback(hObject, eventdata, handles)
% hObject    handle to moveUpButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

contents = get(handles.allNodesList,'String');
numSelected = get(handles.allNodesList,'Value');
if numSelected ~= 1
    tempSave = contents{numSelected-1}(11:end);
    contents{numSelected-1} = [contents{numSelected-1}(1:10) contents{numSelected}(11:end)];
    contents{numSelected} = [contents{numSelected}(1:10) tempSave];
    set(handles.allNodesList,'String',contents)
    set(handles.allNodesList,'Value',numSelected-1)
end
% --- Executes on button press in MoveDownButton.
function MoveDownButton_Callback(hObject, eventdata, handles)
% hObject    handle to MoveDownButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

contents = get(handles.allNodesList,'String');
numSelected = get(handles.allNodesList,'Value');
if numSelected ~= length(contents)
    tempSave = contents{numSelected}(11:end);
    contents{numSelected} = [contents{numSelected}(1:10) contents{numSelected+1}(11:end)];
    contents{numSelected+1} = [contents{numSelected+1}(1:10) tempSave];
    set(handles.allNodesList,'String',contents)
    set(handles.allNodesList,'Value',numSelected+1)
end


% --- Executes on button press in cancelButton.
function cancelButton_Callback(hObject, eventdata, handles)
% hObject    handle to cancelButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

eval('newNodeList = ''''; ');
savePath = what('ncsEditor');
save([savePath.path '\temp'],'newNodeList');
delete(handles.nodeGui);


% --- Executes when user attempts to close nodeGui.
function nodeGui_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to nodeGui (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
eval('newNodeList = ''''; ');
savePath = what('ncsEditor');
save([savePath.path '\temp'],'newNodeList');
delete(hObject);


% --- Executes during object creation, after setting all properties.
function AddInOut_CreateFcn(hObject, eventdata, handles)
% hObject    handle to AddInOut (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function nodeText_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nodeText (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
set(hObject,'String','Node: 1')
